﻿//Copyright (C) Microsoft Corporation.  All rights reserved.

using System;
using System.Collections.Generic;
using System.Text;
using System.Linq;
using Microsoft.VisualStudio.DebuggerVisualizers;
using System.Linq.Expressions;
using ExpressionVisualizer;

namespace LINQConsoleApplication1 {
    class Program {

        //The Expression Tree Visualizer can be used in a debug environment to visualize expressions.  To use 
        //the visualizer the dll generated by the ExpressionTreeVisualizer project must be copied to 
        // \My Documents\Visual Studio 2008\Visualizers.  This console program provides the ability to
        //host the visualizer outside of Visual Studio without copying the DLL.
        static void Main() 
        {
            string introduction = "The Visualizer may be hidden behind a window. Try the GuiHost.";

            Console.WriteLine(introduction);

            Expression<Func<int, bool>> expr = x => x == 10;

            VisualizerDevelopmentHost host = new VisualizerDevelopmentHost(expr,
                                                 typeof(ExpressionTreeVisualizer),
                                                 typeof(ExpressionTreeVisualizerObjectSource));
            host.ShowVisualizer();   
            

        }
    }
}
